<?php

namespace Fastrack\Settings;

use Fastrack\Utilities\ModelUtilities;
use SilverStripe\Forms\FieldList;
use SilverStripe\Forms\GridField\GridField;
use SilverStripe\Forms\GridField\GridFieldConfig_RecordEditor;
use SilverStripe\Forms\HeaderField;
use SilverStripe\Forms\TextField;
use SilverStripe\ORM\DataExtension;

class SocialMediaExtension extends DataExtension
{

	private static $db = [
		'Facebook' => 'Varchar(255)',
		'Twitter' => 'Varchar(255)',
		'GoogleMyBusiness' => 'Varchar(255)',
		'Instagram' => 'Varchar(255)',
		'Youtube' => 'Varchar(255)',
		'TripAdvisor' => 'Varchar(255)',
		'LinkedIn' => 'Varchar(255)'
	];

	private static $has_many = [
		'InstagramTokens' => InstagramToken::class,
	];

	public function updateCMSFields(FieldList $fields)
	{
		$fields->addFieldsToTab('Root.SocialMedia', [
			HeaderField::create('SocialMediaHeader', 'Social media'),
			TextField::create('Facebook'),
			TextField::create('Twitter'),
			TextField::create('GoogleMyBusiness'),
			TextField::create('Instagram'),
			TextField::create('Youtube'),
			TextField::create('TripAdvisor'),
			TextField::create('LinkedIn'),
			new GridField(
				'InstagramTokens',
				'Instagram Tokens',
				$this->getOwner()->InstagramTokens(),
				GridFieldConfig_RecordEditor::create()
			),
		]);
		ModelUtilities::hideFields($this->getOwner(), $fields);
	}

}
